  use32 		;  32- ० ᥬ
  org	 0		;   

  db	 'MENUET01'	; 8- 䨪 MenuetOS
  dd	 1		;   (ᥣ 1)
  dd	 start		;  ࢮ 
  dd	 i_end		; ࠧ ணࠬ
  dd	 mem		; ⢮ 
  dd	 stack_top	;  設 
  dd	 sParam 	;    ࠬ஢
  dd	 0		;       ⮩ ண


include '../../include/macros.inc'
include '../../include/proc32.inc'
include 'debug.inc'

macro split_space
{
local .l1,.l2
  .l1:
	cmp	byte[esi],' '
	jne	.l2
	inc	esi
	jmp	.l1
  .l2:
}

MIN_USER_SLOT equ 6
NAME_LENGTH   equ 11

;-------------------------------------------------------------------------------
start:
	mcall	68,11	;InitHeap

	cmp	byte[sParam],0
	jne	@f
	mcall	70,notify
	mcall	-1
   @@:

	stdcall FindParam,p_x
	cmp	eax,-1
	jne	X
	mov	[d_x],16	 ;祭  㬮砭
	jmp	@f
X:
	stdcall StrToInt,eax
	mov	[d_x],eax

;-------------------------------------------------------------------------------
@@:
	stdcall FindParam,p_y
	cmp	eax,-1
	jne	Y
	mov	[d_y],16	 ;祭  㬮砭
	jmp	@f
Y:
	stdcall StrToInt,eax
	mov	[d_y],eax

;-------------------------------------------------------------------------------
@@:
	stdcall FindParam,p_icon
	cmp	eax,-1
	jne	ic
    def:
	mov	[d_icon],'0'
	mov	[d_icon+1],0	 ;祭  㬮砭
	jmp	next1
ic:
	mov	esi,eax
	mov	edi,d_icon
  @@:	lodsb
	cmp	al,'0'
	jb	ic_end
	cmp	al,'9'
	ja	ic_end
	stosb
	jmp	@b

ic_end:
	cmp	edi,d_icon
	je	def

;-------------------------------------------------------------------------------
next1:
	stdcall FindParam,p_name
	cmp	eax,-1
	jne	nm
def_name:
	mov	eax,defolt_name  ;祭  㬮砭
nm:
	cmp	byte[eax],'"'
	jne	def_name

	inc	eax
	mov	esi,eax
	mov	edi,d_name
  @@:	lodsb
	cmp	al,'"'
	je	next1_1
	stosb
	jmp	@b
next1_1:
	mov	byte[edi],0


;------------------------------------------------------------------------------

	stdcall FindParam,p_path
	cmp	eax,-1
	jne	pt
	mcall	70,notify
	neg eax
	dph eax
	dnl
	dps    ' 㪠 '
	dnl

;        mov     eax,defolt_name  ;祭  㬮砭
	jmp	exit
pt:
	cmp	byte[eax],'"'
	jne	exit

	inc	eax
	mov	esi,eax
	mov	edi,d_path
  @@:	lodsb
	cmp	al,'"'
	je	next2_1
	stosb
	jmp	@b
next2_1:
	mov	byte[edi],0


;------------------------------------------------------------------------------
	stdcall FindParam,p_param
	cmp	eax,-1
	jne	pr
	jmp	send
pr:
	mov	esi,eax
	mov	edi,d_param
  @@:	lodsb
	stosb
	test	al,al
	jnz	@b


;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
;------------------------------------------------------------------------------
send:
; PIDicon ////////////////////////////////////////////
	mov	ecx,MIN_USER_SLOT

 search:
	mcall	9,bufPrcss
	mov	edx,eax

	mov	esi,bufPrcss+10
	mov	edi,nameIconPrc

    @@: lodsb
	cmp	al,61h
	jb	.s
	sub	al,20h
       .s:
	scasb
	jnz	.fail
	test	al,al
	jnz	@b
     ;:
	m2m	[PIDicon],dword[bufPrcss+30]
	jmp	prepare
 .fail:
	inc	ecx
	cmp	ecx,edx
	jbe	search

; :
dps  ' @icon  '
dnl
	jmp	exit

;⮢  ///////////////////////////////////////////
prepare:

	mcall	68,12,4096
	mov	[OffsData],eax
	mov	edi,eax

	mov	eax,[d_x]
	mov	[edi],eax
	add	edi,4

	mov	eax,[d_y]
	mov	[edi],eax
	add	edi,4


	mov	esi,d_icon
    @@: lodsb
	stosb
	test	al,al
	jnz	@b

	mov	ecx,NAME_LENGTH+1
	mov	esi,d_name
    @@: lodsb
	stosb
	test	al,al
	jz	@f
	loop	@b
    @@:
	mov	esi,d_path
    @@: lodsb
	stosb
	test	al,al
	jnz	@b

	mov	esi,d_param
    @@: lodsb
	stosb
	test	al,al
	jnz	@b

; ᮮ饭 ////////////////////////////////////////////////////
	mov	edx,[OffsData]
	mov	esi,edi
	sub	esi,edx

dph esi
dnl

    @@: mcall	60,2,[PIDicon];[OffsData], [SizeData]
	test	eax,eax
	jz	.ok
	cmp	eax,2
	jne	.err
	mcall	5,1
	jmp	@b
    .err:
	cmp	eax,1
	jne	@f

	dps '@icon  ਭ IPC ᮮ饭 '
	dnl
	dps ', ⮨   @icon'
	dnl
	jmp	exit
    @@:
	cmp	eax,4
	jne	@f

	dps ' @icon   '
	dnl
	jmp	exit
    @@:

	dps '। 訡 '
	dph eax
	dnl
	jmp	exit

     .ok:
	dps  'ࠢ ᯥ譮'


exit:
	mcall	-1

;-------------------------------------------------------------------------------
proc FindParam prm
	push	edi esi
	mov	edi,sParam

	mov	esi,[prm]
	mov	ecx,1024
   @@:
	lodsb
	test	al,al
	jz	.ok
	dec	ecx
	scasb
	jz	@b

	mov	esi,[prm]
	test	ecx,ecx
	jnz	@b
.fail:
	or	eax,-1
	jmp	.exit
.ok:
	cmp	byte[edi],' '
	jne	.fail
	mov	esi,edi
	split_space
	mov	eax,esi
.exit:
	pop	esi edi
	ret
endp


proc StrToInt pnt
locals
    minus rd 1
endl
	push	ebx edi
	mov	edi,[pnt]
	xor	ebx,ebx
	xor	eax,eax
	mov	cx,10

	mov	bl,[edi]
	mov	[minus],0
	cmp	bl,'-'
	jne	@f
	inc	edi
	mov	[minus],1
     @@:


.cykl:
	mov	bl,[edi]
	inc	edi
	cmp	bl,'0'
	jb	.endcykl
	cmp	bl,'9'
	ja	.endcykl
	sub	bl,30h
	mul	cx
	add	eax,ebx
	jmp	.cykl
.endcykl:
	cmp	[minus],0
	je	.end
	neg	eax
.end:
	pop	edi ebx
	ret
endp

;---------------------------------------------------------------------
;---    --------------------------------------------------------
;---------------------------------------------------------------------

comline db 'newlnk -x 128 -y 256 -icon 3 -name "MyLink" -path "/rd/1/run" -param parapaparam',0

p_x	db '-x',0
p_y	db '-y',0
p_icon	db '-icon',0
p_name	db '-name',0
p_path	db '-path',0
p_param db '-param',0

d_x	 rd 1
d_y	 rd 1
d_icon	 rb 256
d_name	 rb 256
d_path	 rb 256
d_param  rb 256

defolt_name db '"New link"',0

nameIconPrc db '@ICON',0

notify:
	dd 7
	dd 0
	dd comline
	dd 0
	dd 0
	db '/rd/1/@NOTIFY',0

;sParam db '-x 128 -y 256 -icon 3 -name "MyLink" -path "/rd/1/run" -param',0


i_end:

;-------------------------------------------------------------------------------
;--------- 樠஢  ணࠬ--------------------------------
;-------------------------------------------------------------------------------
PIDicon rd 1
OffsData rd 1


bufPrcss rb 1024


sParam	rb 1024

	rb 1024    ;stack
stack_top:

mem:






